Loading...
Searching...
No Matches
RadiusManager.idl
/* SPDX-License-Identifier: BSD-3-Clause */
/*
* Copyright 2012 Raritan Inc. All rights reserved.
*/
/** Local and Remote Authentication Management */
module auth {
/** RADIUS server configuration interface */
interface RadiusManager {
/** RADIUS auth type */
enumeration AuthType {
PAP, ///< PAP authentication
CHAP, ///< CHAP authentication
MSCHAPv2 ///< MSCHAPv2 authentication
};
/** Server settings */
structure ServerSettings {
string id; ///< This field is unused; empty on read, ignored on write
string server; ///< IP or name of the radius servers
string sharedSecret; ///< Shared secret between the Xerus device and the RADIUS server
int udpAuthPort; ///< UDP port for RADIUS Authenticating service
int udpAccountPort;///< UDP port for RADIUS Accounting service
int timeout; ///< Timeout in seconds
int retries; ///< Number of retries
AuthType authType; ///< Authentication type
boolean disableAccounting;///< \c true to disable accounting, \c false to enable accounting
boolean messageAuthenticatorOptional; ///< \c true if not requiring Message-Authenticator attribute in reply to Access-Request
};
constant int ERR_INVALID_CFG = 1; ///< The server configuration is invalid
constant int ERR_SERVER_UNSPECIFIED = 2; ///< Unspecified error
constant int ERR_INVALID_SHARED_SECRET = 3; ///< The shared secret is invalid
constant int ERR_SERVER_UNREACHABLE = 4; ///< RADIUS server could not be contacted
constant int ERR_AUTHENTICATION_FAILED = 5; ///< User could not be authenticated
constant int ERR_NO_ROLES = 6; ///< No roles are defined for the user
constant int ERR_NO_KNOWN_ROLES = 7; ///< No known rules are defined for the user
constant int ERR_MSG_AUTH_ATTR_MISSING = 8; ///< Message-Authenticator attribute missing in Access-Request reply
/**
* Get a list of RADIUS server settings
*
* @return list of ServerSettings
*/
vector<ServerSettings> getRadiusServers();
/**
* Sets a list of RADIUS servers.
* Any existing RADIUS Server configuration will be cleared / overwritten.
*
* @return 0 on success
* @return \c ERR_INVALID_CFG in case of invalid configuration
*/
int setRadiusServers(in vector<ServerSettings> serverList);
/**
* Tests an RADIUS server configuration.
*
* @return 0 on success
* @return \c ERR_SERVER_UNSPECIFIED an unspecified error occurred
* @return \c ERR_INVALID_CFG RADIUS server configuration is invalid (reused from setRadiusServers)
* @return \c ERR_INVALID_SHARED_SECRET the shared secret is invalid
* @return \c ERR_SERVER_UNREACHABLE RADIUS server could not be contacted
* @return \c ERR_AUTHENTICATION_FAILED user could not be authenticated
* @return \c ERR_NO_ROLES no roles are defined for the user
* @return \c ERR_NO_KNOWN_ROLES no known roles are defined for the user
* @return \c ERR_MSG_AUTH_ATTR_MISSING Message-Authenticator attribute missing in Access-Request reply
*/
int testRadiusServer(in string username, in string password, in ServerSettings settings);
};
}
auth::RadiusManager
RADIUS server configuration interface.
Definition RadiusManager.idl:10
auth::RadiusManager::setRadiusServers
int setRadiusServers(in vector< ServerSettings > serverList)
Sets a list of RADIUS servers.
auth::RadiusManager::testRadiusServer
int testRadiusServer(in string username, in string password, in ServerSettings settings)
Tests an RADIUS server configuration.
auth::RadiusManager::AuthType
AuthType
RADIUS auth type.
Definition RadiusManager.idl:13
auth::RadiusManager::CHAP
@ CHAP
CHAP authentication.
Definition RadiusManager.idl:15
auth::RadiusManager::PAP
@ PAP
PAP authentication.
Definition RadiusManager.idl:14
auth::RadiusManager::getRadiusServers
vector< ServerSettings > getRadiusServers()
Get a list of RADIUS server settings.
auth
Local and Remote Authentication Management.
Definition AuthManager.idl:7
auth::RadiusManager::ServerSettings
Server settings.
Definition RadiusManager.idl:20
auth::RadiusManager::ServerSettings::timeout
int timeout
Timeout in seconds.
Definition RadiusManager.idl:26
auth::RadiusManager::ServerSettings::id
string id
This field is unused; empty on read, ignored on write.
Definition RadiusManager.idl:21
auth::RadiusManager::ServerSettings::server
string server
IP or name of the radius servers.
Definition RadiusManager.idl:22
auth::RadiusManager::ServerSettings::messageAuthenticatorOptional
boolean messageAuthenticatorOptional
true if not requiring Message-Authenticator attribute in reply to Access-Request
Definition RadiusManager.idl:30
auth::RadiusManager::ServerSettings::sharedSecret
string sharedSecret
Shared secret between the Xerus device and the RADIUS server.
Definition RadiusManager.idl:23
auth::RadiusManager::ServerSettings::udpAuthPort
int udpAuthPort
UDP port for RADIUS Authenticating service.
Definition RadiusManager.idl:24
auth::RadiusManager::ServerSettings::disableAccounting
boolean disableAccounting
true to disable accounting, false to enable accounting
Definition RadiusManager.idl:29
auth::RadiusManager::ServerSettings::retries
int retries
Number of retries.
Definition RadiusManager.idl:27
auth::RadiusManager::ServerSettings::authType
AuthType authType
Authentication type.
Definition RadiusManager.idl:28
auth::RadiusManager::ServerSettings::udpAccountPort
int udpAccountPort
UDP port for RADIUS Accounting service.
Definition RadiusManager.idl:25